//+----------------------------------------------------------+
//|                                                          |
//|                  FX_Guage EA v3.mq4                    |
//|               Customer Name: Ed Crivello                 |
//|                    Date: 25-Oct-2010                     |
//+----------------------------------------------------------+
#property link      "http://www.pro-fx-experts.com"
#property copyright "Copyright  2010, Ed Crivello"

extern int    MAGIC_NUMBER          = 123467;

extern bool   Use_Time_Settings     = false;
extern string Asian_Open            = "07:00";
extern string Asian_Close           = "20:00";
extern string London_Open           = "07:00";
extern string London_Close          = "20:00";
extern string US_Open               = "07:00";
extern string US_Close              = "20:00";

extern double Lots                  = 0.2;
extern bool   Use_Partial_Lots      = false;
extern double Partial_Lots          = 0.1;
extern int    Partial_TakeProfit    = 20;

extern int    TakeProfit            = 20;
extern int    Stoploss              = 25;
extern int    Slippage              = 3;

extern bool   Trade_Full_Vanilla    = true;
extern bool   Reverse_Trading       = false;
extern bool   Loss_Reverse          = false;

extern bool   TrailingOrders        = false;
extern int    TrailingStop          = 25;

extern bool   Show_Comment          = true;
extern string EAName                = "FX_Guage V3"; 

//----------------------------------------------------------------------------------------------------------// 
int cnt, Ticket, magic, adjdigits=1;
string RTYN,LRYN,TRSYN,TOYN,Van,PLYN;

//----------------------------------------------------------------------------------------------------------// 

int init(){
 magic = MakeMagicNumber(MAGIC_NUMBER);
 StartBuy(); 
 StartSell();
}

int deinit(){return (0);}

//----------------------------------------------------------------------------------------------------------// 

int start(){

RefreshRates(); 

 if (Digits == 5 || Digits == 3) { adjdigits = 10; }  

 int Buys = CountBuys(magic);
 int Sells = CountSells(magic);
 int CntLossOrds = CountLossOrders(magic);
 
//----------------------------------------------------------------------------------------------------------//  
 double M1=0, M5=0, M15=0, H1=0, M1_1=0, M5_1=0, M15_1=0, H1_1=0, ProfitLoss=0;
 color  cM1=0, cM5=0, cM15=0, cH1=0;
 int    LOrdType;
 string LastOrdCom = "";
 
 LOrdType = LastOrdType(magic);
 ProfitLoss = LastProfLoss(magic);
 LastOrdCom = LastOrdComm(magic);

 M1 = ObjectGet("fml_bar_0_0",OBJPROP_PRICE1);
 M5 = ObjectGet("fml_bar_1_0",OBJPROP_PRICE1);
 M15 = ObjectGet("fml_bar_2_0",OBJPROP_PRICE1);
 H1 = ObjectGet("fml_bar_3_0",OBJPROP_PRICE1);
 
 M1_1 = ObjectGet("fml_bar_0_1",OBJPROP_PRICE1);
 M5_1 = ObjectGet("fml_bar_1_1",OBJPROP_PRICE1);
 M15_1 = ObjectGet("fml_bar_2_1",OBJPROP_PRICE1);
 H1_1 = ObjectGet("fml_bar_3_1",OBJPROP_PRICE1);
  
 cM1 = ObjectGet("fml_bar_0_0",OBJPROP_COLOR);
 cM5 = ObjectGet("fml_bar_1_0",OBJPROP_COLOR);
 cM15 = ObjectGet("fml_bar_2_0",OBJPROP_COLOR);
 cH1 = ObjectGet("fml_bar_3_0",OBJPROP_COLOR);
 
 
 string   date = TimeToStr(TimeCurrent(),TIME_DATE);
 
 datetime Ses_1_Start = StrToTime(date+" "+Asian_Open);//-86400
 datetime Ses_1_Stop  = StrToTime(date+" "+Asian_Close); 
 datetime Ses_2_Start = StrToTime(date+" "+London_Open);//-86400
 datetime Ses_2_Stop  = StrToTime(date+" "+London_Close); 
 datetime Ses_3_Start = StrToTime(date+" "+US_Open);
 datetime Ses_3_Stop  = StrToTime(date+" "+US_Close);
 
 if(Ses_1_Start>Ses_1_Stop) {Ses_1_Stop=(Ses_1_Stop+86400);}
 if(Ses_1_Start<Ses_1_Stop) {Ses_1_Stop=Ses_1_Stop;}
   
 if(Ses_2_Start>Ses_2_Stop) {Ses_2_Stop=(Ses_2_Stop+86400);}
 if(Ses_2_Start<Ses_2_Stop) {Ses_2_Stop=Ses_2_Stop;}   
 
 if(Ses_3_Start>Ses_3_Stop) {Ses_3_Stop=(Ses_3_Stop+86400);}
 if(Ses_3_Start<Ses_3_Stop) {Ses_3_Stop=Ses_3_Stop;}
 
 if(TrailingOrders) {Trail_Orders(magic);}
 
//----------------------------------------------------------------------------------------------------------//  

if(!Reverse_Trading && M1<M5 && ObjectFind("SB "+Symbol())>=0 && M1>0 && M5>0){ObjectDelete("SB "+Symbol());}
if(Reverse_Trading && M1>M5 && ObjectFind("SB "+Symbol())>=0 && M1>0 && M5>0){ObjectDelete("SB "+Symbol());}

if(!Reverse_Trading && M1>M5 && ObjectFind("SS "+Symbol())>=0 && M1>0 && M5>0){ObjectDelete("SS "+Symbol());} 
if(Reverse_Trading && M1<M5 && ObjectFind("SS "+Symbol())>=0 && M1>0 && M5>0){ObjectDelete("SS "+Symbol());}

//----------------------------------------------------------------------------------------------------------//  

if((Buys+Sells)>0){

for(cnt=0;cnt<OrdersTotal();cnt++)
 {
  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && (TimeCurrent())>OrderOpenTime())
     {
     if(OrderType()==OP_BUY && OrderTakeProfit()==0 && TakeProfit>0) 
        {OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),Ask+TakeProfit*adjdigits*Point,0,Green);}
     
          
     if(OrderType()==OP_SELL && OrderTakeProfit()==0 && TakeProfit>0)
       {OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),Bid-TakeProfit*adjdigits*Point,0,Red);}
     }
}

for(cnt=0;cnt<OrdersTotal();cnt++)
 {
  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && (TimeCurrent())>OrderOpenTime())
     {
     if(OrderType()==OP_BUY && OrderStopLoss()==0 && Stoploss>0) 
        {OrderModify(OrderTicket(),OrderOpenPrice(),Ask-Stoploss*adjdigits*Point,OrderTakeProfit(),0,Green);}
           
     if(OrderType()==OP_SELL && OrderStopLoss()==0 && Stoploss>0)
       {OrderModify(OrderTicket(),OrderOpenPrice(),Bid+Stoploss*adjdigits*Point,OrderTakeProfit(),0,Red);}
     }
 }
}
//----------------------------------------------------------------------------------------------------------// 

if((Buys+Sells)>0 && Use_Partial_Lots==true && Partial_Lots<Lots){
     for(int b1e=0;b1e<OrdersTotal();b1e++){
       OrderSelect(b1e, SELECT_BY_POS, MODE_TRADES);
         if(OrderType()<=1 && OrderSymbol()==Symbol() && OrderMagicNumber()==magic) {
            if(OrderType()==OP_BUY && Ask>=OrderOpenPrice()+Partial_TakeProfit*adjdigits*Point && OrderLots()==Lots) 
              { OrderClose(OrderTicket(), Partial_Lots, MarketInfo(OrderSymbol(), MODE_BID), Slippage, White);}
            if(OrderType()==OP_SELL && Bid<=OrderOpenPrice()-Partial_TakeProfit*adjdigits*Point && OrderLots()==Lots)
              { OrderClose(OrderTicket(), Partial_Lots, MarketInfo(OrderSymbol(), MODE_ASK), Slippage, White);}
          }
     }
}

//----------------------------------------------------------------------------------------------------------// 
 
 for(cnt=0;cnt<OrdersTotal();cnt++)
      {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
         {
            if(Buys>0 && OrderType()==OP_BUY && !OrderLots()==Lots && OrderStopLoss()<OrderOpenPrice() && OrderStopLoss()>0) 
            {OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,White);}
           
            if(Sells>0 && OrderType()==OP_SELL && !OrderLots()==Lots && OrderStopLoss()>OrderOpenPrice() && OrderStopLoss()>0)
            {OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Yellow);}
      }
   }

//----------------------------------------------------------------------------------------------------------// 
if(Loss_Reverse==true && ProfitLoss<0 && Buys==0 && Sells==0 && !ObjectFind("LossRev "+Symbol())>=0 && (LastOrdCom!=EAName+"_LRB" && LastOrdCom!=EAName+"_LRS")){
LossRev();}

if(Loss_Reverse==true && CntLossOrds>0 && ObjectFind("LossRev "+Symbol())>=0){
ObjectDelete("LossRev "+Symbol());}

//----------------------------------------------------------------------------------------------------------// 

 if(Buys>0 && !ObjectFind("BuyMark "+Symbol())>=0){BuyMark();}
 if(Sells>0 && !ObjectFind("SellMark "+Symbol())>=0){SellMark();}
 
if(Reverse_Trading==false){
 if(Buys==0 && ObjectFind("BuyMark "+Symbol())>=0 && M1<M5){ObjectDelete("BuyMark "+Symbol());}
 if(Sells==0 && ObjectFind("SellMark "+Symbol())>=0 && M1>M5){ObjectDelete("SellMark "+Symbol());}
}

if(Reverse_Trading==true){
 if(Buys==0 && ObjectFind("BuyMark "+Symbol())>=0 && M1>M5){ObjectDelete("BuyMark "+Symbol());}
 if(Sells==0 && ObjectFind("SellMark "+Symbol())>=0 && M1<M5){ObjectDelete("SellMark "+Symbol());}
}
 
//----------------------------------------------------------------------------------------------------------// 

if(((Use_Time_Settings==true && TimeCurrent()>=Ses_1_Start && TimeCurrent()<=Ses_1_Stop) || Use_Time_Settings==false) ||
   ((Use_Time_Settings==true && TimeCurrent()>=Ses_2_Start && TimeCurrent()<=Ses_2_Stop) || Use_Time_Settings==false) ||
   ((Use_Time_Settings==true && TimeCurrent()>=Ses_3_Start && TimeCurrent()<=Ses_3_Stop) || Use_Time_Settings==false)){

if(Reverse_Trading==false){
 if(Buys==0 && Sells==0 && !ObjectFind("BuyMark "+Symbol())>=0 && !ObjectFind("LossRev "+Symbol())>=0 && !ObjectFind("SB "+Symbol())>=0 &&
    M1>M5 && M1>M15 && M1>H1 && 
    cM1==32768 && cM5==32768 && cM15==32768 && cH1==32768 &&
    M1>0 && M5>0 && M15>0 && H1>0 && 
    ((Trade_Full_Vanilla==false) || (Trade_Full_Vanilla==true && M5>M15 && M15>H1 && M1_1>M5_1 && M1_1>M15_1 && M1_1>H1_1 && M5_1>M15_1 && M15_1>H1_1)) &&
    Ask>M1){OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,0,0,EAName+"_Buy",magic,0,Blue);}

 if(Buys==0 && Sells==0 && !ObjectFind("SellMark "+Symbol())>=0 && !ObjectFind("LossRev "+Symbol())>=0 && !ObjectFind("SS "+Symbol())>=0 && 
    M1<M5 && M1<M15 && M1<H1 && 
    cM1==2237106 && cM5==2237106 && cM15==2237106 && cH1==2237106 && 
    M1>0 && M5>0 && M15>0 && H1>0 && 
    ((Trade_Full_Vanilla==true) || (Trade_Full_Vanilla==false && M5<M15 && M15<H1 && M1_1<M5_1 && M1_1<M15_1 && M1_1<H1_1 && M5_1<M15_1 && M15_1<H1_1)) &&
    Bid<M1){OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,0,0,EAName+"_Sell",magic,0,Red);}
} 
//----------------------------------------------------------------------------------------------------------// 

if(Reverse_Trading==true){
 if(Buys==0 && Sells==0 && !ObjectFind("SellMark "+Symbol())>=0 && !ObjectFind("LossRev "+Symbol())>=0 && !ObjectFind("SS "+Symbol())>=0 && 
    M1>M5 && M1>M15 && M1>H1 && 
    cM1==32768 && cM5==32768 && cM15==32768 && cH1==32768 &&
    M1>0 && M5>0 && M15>0 && H1>0 && 
    ((Trade_Full_Vanilla==false) || (Trade_Full_Vanilla==true && M5>M15 && M15>H1 && M1_1>M5_1 && M1_1>M15_1 && M1_1>H1_1 && M5_1>M15_1 && M15_1>H1_1)) &&
    Ask>M1){OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,0,0,EAName+"_Sell",magic,0,Khaki);}

 if(Buys==0 && Sells==0 && !ObjectFind("BuyMark "+Symbol())>=0 && !ObjectFind("LossRev "+Symbol())>=0 && !ObjectFind("SB "+Symbol())>=0 && 
    M1<M5 && M1<M15 && M1<H1 && 
    cM1==2237106 && cM5==2237106 && cM15==2237106 && cH1==2237106 && 
    M1>0 && M5>0 && M15>0 && H1>0 && 
    ((Trade_Full_Vanilla==false) || (Trade_Full_Vanilla==true && M5<M15 && M15<H1 && M1_1<M5_1 && M1_1<M15_1 && M1_1<H1_1 && M5_1<M15_1 && M15_1<H1_1)) &&
    Bid<M1){OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,0,0,EAName+"_Buy",magic,0,White);}
}

//----------------------------------------------------------------------------------------------------------// 
if(Loss_Reverse==true && (LastOrdCom!=EAName+"_LRB" && LastOrdCom!=EAName+"_LRS")){
 if(LOrdType==1 && ProfitLoss<0 && Buys==0 && Sells==0 && ObjectFind("LossRev "+Symbol())>=0 && !ObjectFind("SB "+Symbol())>=0){
    OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,0,0,EAName+"_LRB",magic,0,Blue);}

 if(LOrdType==0 && ProfitLoss<0 && Buys==0 && Sells==0 && ObjectFind("LossRev "+Symbol())>=0 && !ObjectFind("SS "+Symbol())>=0){
    OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,0,0,EAName+"_LRS",magic,0,Red);}
 }

} // Time setting stop

//----------------------------------------------------------------------------------------------------------// 
if(Reverse_Trading==true) {RTYN="Yes";} else {RTYN="No";} 
if(Loss_Reverse==true) {LRYN="Yes";} else {LRYN="No";} 
if(TrailingOrders==true) {TOYN="Yes";} else {TOYN="No";} 
if(Use_Time_Settings==true) {TRSYN="Yes";} else {TRSYN="No";} 
if(Trade_Full_Vanilla==true){Van="Full";} else {Van="Semi";}
if(Use_Partial_Lots==true) {PLYN="Yes";} else {PLYN="No";}

if(Show_Comment){

Comment ("\n                               " + EAName +"          MagicNumber: " + magic
		  +"\n                               ---------------------------------------------------------------"
		  +"\n                               Current Server Time   : " + TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)	
        +"\n                               Account Balance         : " + DoubleToStr(NormalizeDouble(AccountBalance(),2),2)
        +"\n                               Account Free margin   : " + DoubleToStr(NormalizeDouble(AccountEquity(),2),2)			  
		  +"\n                               Lots                           : " + DoubleToStr(NormalizeDouble(Lots,2),2)
		  +"\n                               Use Partial Lots          : " + PLYN
		  +"\n                               Partial Lots                 : " + DoubleToStr(NormalizeDouble(Partial_Lots,2),2)
		  +"\n                               TakeProfit                  : " + TakeProfit	
		  +"\n                               Stoploss                     : " + Stoploss	
		  +"\n                               Use Trailing                : " + TOYN		  
		  +"\n                               Trailing Pips                : " + TrailingStop		  
		  +"\n                               ---------------------------------------------------------------"		  
		  +"\n                               Reverse Trading          : " + RTYN
		  +"\n                               Reverse on Loss          : " + LRYN
		  +"\n                               Vanilla Setup Type      : " + Van
		  
		  +"\n                               ---------------------------------------------------------------"
		  +"\n                               Use Time Settings       : " + TRSYN
		  +"\n                               Asian Open                : " + TimeToStr(Ses_1_Start,TIME_MINUTES)
		  +"\n                               Asian Close                : " + TimeToStr(Ses_1_Stop,TIME_MINUTES)
		  +"\n                               London Open              : " + TimeToStr(Ses_2_Start,TIME_MINUTES)
		  +"\n                               London Close              : " + TimeToStr(Ses_2_Stop,TIME_MINUTES)
		  +"\n                               US Open                   : " + TimeToStr(Ses_3_Start,TIME_MINUTES)
		  +"\n                               US Close                   : " + TimeToStr(Ses_3_Stop,TIME_MINUTES)
		  +"\n                               ---------------------------------------------------------------");
}

        ObjectCreate("CC", OBJ_LABEL, 0, 0, 0);
        ObjectSet("CC", OBJPROP_CORNER, 3);
        ObjectSet("CC", OBJPROP_XDISTANCE, 5);
        ObjectSet("CC", OBJPROP_YDISTANCE, 5);
        ObjectSet("CC", OBJPROP_BACK, true);
        ObjectSetText("CC", "Copyright  "+Year()+", Ed Crivello - Pro-Fx-Experts.com", 8, "Arial", Silver);


//----------------------------------------------------------------------------------------------------------// 

return (0);

}
//----------------------------------------------------------------------------------------------------------// 

void Trail_Orders(int MagicNumber){

      for(cnt=0;cnt<OrdersTotal();cnt++)
      {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderType()<=1 && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
            if(OrderType()==OP_BUY) 
            {if((Bid-OrderOpenPrice())>(Point*TrailingStop*adjdigits) && OrderStopLoss()<(Bid-Point*TrailingStop*adjdigits)-Point)
               {OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop*adjdigits,OrderTakeProfit(),0,Green);}}
           
            if(OrderType()==OP_SELL)
            {if(((OrderOpenPrice()-Ask)>(Point*TrailingStop*adjdigits) && OrderStopLoss()>(Ask+Point*TrailingStop*adjdigits)+Point) || ((OrderOpenPrice()-Ask)>(Point*TrailingStop*adjdigits) && OrderStopLoss()==0))
            {OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop*adjdigits,OrderTakeProfit(),0,Red);}}
      }
   } 
}
//----------------------------------------------------------------------------------------------------------// 

int CountBuys(int MagicNumber)
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if( OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber)
   continue;
   
  if(OrderType()==OP_BUY)
   count++;
 }
 return(count);
}
//----------------------------------------------------------------------------------------------------------// 
int CountSells(int MagicNumber)
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber)
   continue;
   
  if(OrderType()==OP_SELL)
  count++;
 }
 return(count);
}

//----------------------------------------------------------------------------------------------------------// 

int MakeMagicNumber(int ExpertID)
{
   int SymbolCode  = 0;
   int MagicNumber = 0; 
   
   //---- Symbol() Code
   
        if( StringFind(Symbol(),"AUDCAD",0)>-1 ) { SymbolCode = 1000; }
   else if( StringFind(Symbol(),"AUDJPY",0)>-1 ) { SymbolCode = 2000; }
   else if( StringFind(Symbol(),"AUDNZD",0)>-1 ) { SymbolCode = 3000; }
   else if( StringFind(Symbol(),"AUDUSD",0)>-1 ) { SymbolCode = 4000; }
   else if( StringFind(Symbol(),"CHFJPY",0)>-1 ) { SymbolCode = 5000; }
   else if( StringFind(Symbol(),"EURAUD",0)>-1 ) { SymbolCode = 6000; }
   else if( StringFind(Symbol(),"EURCAD",0)>-1 ) { SymbolCode = 7000; }
   else if( StringFind(Symbol(),"EURCHF",0)>-1 ) { SymbolCode = 8000; }
   else if( StringFind(Symbol(),"EURGBP",0)>-1 ) { SymbolCode = 9000; }
   else if( StringFind(Symbol(),"EURJPY",0)>-1 ) { SymbolCode = 2100; }
   else if( StringFind(Symbol(),"EURUSD",0)>-1 ) { SymbolCode = 1100; }
   else if( StringFind(Symbol(),"GBPCHF",0)>-1 ) { SymbolCode = 1200; }
   else if( StringFind(Symbol(),"GBPJPY",0)>-1 ) { SymbolCode = 1300; }
   else if( StringFind(Symbol(),"GBPUSD",0)>-1 ) { SymbolCode = 1400; }
   else if( StringFind(Symbol(),"NZDJPY",0)>-1 ) { SymbolCode = 1500; }
   else if( StringFind(Symbol(),"NZDUSD",0)>-1 ) { SymbolCode = 1600; }
   else if( StringFind(Symbol(),"USDCAD",0)>-1 ) { SymbolCode = 1700; }
   else if( StringFind(Symbol(),"USDCHF",0)>-1 ) { SymbolCode = 1800; }
   else if( StringFind(Symbol(),"USDJPY",0)>-1 ) { SymbolCode = 1900; }
   else { SymbolCode = 1111; }


   //---- Calculate MagicNumber
   MagicNumber = ExpertID+SymbolCode;
   return(MagicNumber);
}
//--------------------------------------------------------------------------------------------------------------------------------//

void BuyMark() { 
 ObjectCreate("BuyMark "+Symbol(), OBJ_ARROW, 0,Time[0],Bid); 
 ObjectSet("BuyMark "+Symbol(),OBJPROP_COLOR,RoyalBlue);
 ObjectSet("BuyMark "+Symbol(),OBJPROP_ARROWCODE,110);
 ObjectSet("BuyMark "+Symbol(),OBJPROP_WIDTH,2);
  return(0); 
}

//--------------------------------------------------------------------------------------------------------------------------------//
void SellMark() { 
 ObjectCreate("SellMark "+Symbol(), OBJ_ARROW, 0,Time[0],Ask); 
 ObjectSet("SellMark "+Symbol(),OBJPROP_COLOR,Tomato);
 ObjectSet("SellMark "+Symbol(),OBJPROP_ARROWCODE,110);
 ObjectSet("SellMark "+Symbol(),OBJPROP_WIDTH,2);
  return(0); 
}
//--------------------------------------------------------------------------------------------------------------------------------//
double LastProfLoss(int MagicNumber)
{
 datetime cur_order = 0; 
 datetime last_order=0; 
 double   LPL=0;
 
   for(int cnts=0;cnts<OrdersHistoryTotal();cnts++)
   {
     OrderSelect(cnts,SELECT_BY_POS,MODE_HISTORY);
      cur_order = OrderCloseTime();
      if(OrderType()<=1 && cur_order>last_order && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      {
         last_order = cur_order;
         LPL = OrderProfit();
      }
   }
   return (LPL);
}
//--------------------------------------------------------------------------------------------------------------------------------//
int LastOrdType(int MagicNumber)
{
 datetime cur_order = 0; 
 datetime last_order=0; 
 int      LPL=0;
 
   for(int cnts=0;cnts<OrdersHistoryTotal();cnts++)
   {
     OrderSelect(cnts,SELECT_BY_POS,MODE_HISTORY);
      cur_order = OrderCloseTime();
      if(OrderType()<=1 && cur_order>last_order && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      {
         last_order = cur_order;
         LPL = OrderType();
      }
   }
   return (LPL);
}

//--------------------------------------------------------------------------------------------------------------------------------//
void LossRev() { 
 ObjectCreate("LossRev "+Symbol(), OBJ_ARROW, 0,Time[0],Ask); 
 ObjectSet("LossRev "+Symbol(),OBJPROP_COLOR,Yellow);
 ObjectSet("LossRev "+Symbol(),OBJPROP_ARROWCODE,244);
 ObjectSet("LossRev "+Symbol(),OBJPROP_WIDTH,1);
  return(0); 
}

//--------------------------------------------------------------------------------------------------------------------------------//
int CountLossOrders(int MagicNumber)
{
 int count=0;
 int trade;
 int trades=OrdersHistoryTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_HISTORY);
  
  if(OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber)
   continue;
   
  if(OrderType()<=1 && OrderCloseTime()>ObjectGet("LossRev "+Symbol(),OBJPROP_TIME1) && ObjectFind("LossRev "+Symbol())>=0)
  count++;
 }
 return(count);
}
//--------------------------------------------------------------------------------------------------------------------------------//
string LastOrdComm(int MagicNumber)
{
 datetime cur_order = 0; 
 datetime last_order=0; 
 string   LORC="";
 
   for(int cnts=0;cnts<OrdersHistoryTotal();cnts++)
   {
     OrderSelect(cnts,SELECT_BY_POS,MODE_HISTORY);
      cur_order = OrderCloseTime();
      if(OrderType()<=1 && cur_order>last_order && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
      {
         last_order = cur_order;
         LORC = StringSubstr(OrderComment(), 0, StringLen(EAName)+4);
      }
   }
   return (LORC);
}
//--------------------------------------------------------------------------------------------------------------------------------//
void StartBuy() { 
 ObjectCreate("SB "+Symbol(), OBJ_ARROW, 0,Time[0],(Ask+Bid)/2); 
 ObjectSet("SB "+Symbol(),OBJPROP_COLOR,Aqua);
 ObjectSet("SB "+Symbol(),OBJPROP_ARROWCODE,158);
 ObjectSet("SB "+Symbol(),OBJPROP_WIDTH,4);
 
  return(0); 
}
void StartSell() { 
 ObjectCreate("SS "+Symbol(), OBJ_ARROW, 0,Time[1],(Ask+Bid)/2); 
 ObjectSet("SS "+Symbol(),OBJPROP_COLOR,White);
 ObjectSet("SS "+Symbol(),OBJPROP_ARROWCODE,158); 
  ObjectSet("SS "+Symbol(),OBJPROP_WIDTH,4);

  return(0); 
}
//--------------------------------------------------------------------------------------------------------------------------------//












